﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;


namespace Sudoku
{
    class Program
    {
        static void Main(string[] args)
        {
            while(true)
            {
                Sudoku sudoku = new Sudoku();
                for (int r = 0; r < 9; r++)
                {
                    bool invalid_input = false;
                    string radek = Console.ReadLine();
                    if (radek.Length != 17)
                    {
                        invalid_input = true;
                    }
                    else
                    {
                        try
                        {
                            string[] inputs = radek.Split(' ');
                            if (inputs.Length != 9)
                            {
                                invalid_input = true;
                            }
                            else
                            {
                                for (int i = 0; i < 9; i++)
                                {
                                    if (inputs[i].Equals("_"))
                                    {
                                        sudoku.AddValue(r, i, -1);
                                    }
                                    else
                                    {
                                        short val = 0;
                                        if (Int16.TryParse(inputs[i], out val))
                                        {
                                            if (val >= 1 && val <= 9)
                                            {
                                                sudoku.AddValue(r, i, val);
                                            }
                                            else
                                            {
                                                invalid_input = true;
                                                break;
                                            }
                                        }
                                        else
                                        {
                                            invalid_input = true;
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                        catch
                        {
                            invalid_input = true;
                        }
                    }
                    if (invalid_input)
                    {
                        Console.WriteLine("Invalid input!");
                        r--;
                        continue;
                    }
                }
                Stopwatch sw = new Stopwatch();             
                Console.WriteLine("Solving...");
                sw.Start();
                bool status = sudoku.Solve();
                sw.Stop();
                Console.WriteLine("Solved! Time: " + sw.ElapsedMilliseconds + "ms");
                if (status)
                    Console.WriteLine(sudoku.ToString());
                else
                    Console.WriteLine("Sudoku could not be solved! :(");
            }
        }
    }
}
